import common
import Image
import gfx

class MyOutput:
    def __init__(self):
        self.cnt_img = 0
    def setparameter(self, key,value):
        print "setparameter",key,value
    def startpage(self, width, height):
        print "startpage", width, height
    def startclip(self, outline):
        print "startclip", outline
    def endclip(self):
        print "endclip"
    def stroke(self, outline, width, color, capstyle, jointstyle, miterLimit):
        print "stroke", outline, width, color, capstyle, jointstyle, miterLimit
    def fill(self, outline, color):
        print "fill", outline, color
    def fillbitmap(self, outline, image, matrix, colortransform):
        print "fillbitmap",outline, image, matrix, colortransform
        #print `image.data`
        im = Image.fromstring('RGB', (image.width, image.height), image.data)
        #im.thumbnail((int(l1),int(l2)), Image.ANTIALIAS)
        im.save('img-%d.jpg' % self.cnt_img, "JPEG")

        self.cnt_img += 1
    def fillgradient(self, outline, gradient, gradienttype, matrix):
        print "fillgradient",outline
    def addfont(self, font):
        print "addfont", font
    def drawchar(self, font, glyph, color, matrix):
        print "drawchar", font, glyph, color, matrix
    def drawlink(self, outline, url):
        print "drawlink", outline, url
    def endpage(self):
        print "endpage"
    def finish(self):
        print "finish"

import sys
docname = "document.pdf"
if len(sys.argv) == 2:
   docname = sys.argv[1]

pagenr = 1
gfx.setparameter("pages", str(pagenr))
doc = gfx.open("pdf", docname)
output = gfx.PassThrough(MyOutput())
doc.getPage(pagenr).render(output)
