import common
import gfx
import sys

pages = "1-2"
gfx.verbose(6)
gfx.setparameter("pages", pages)
doc = gfx.open("pdf", sys.argv[1])

for pagenr in pages.split('-'):
    pagenr = int(pagenr)
    swf = gfx.SWF()
    page = doc.getPage(pagenr)
    swf.startpage(page.width, page.height)
    page.render(swf)
    swf.endpage()

    swf.save("document%04d.swf" % pagenr)
